/******************************************************************************
*                                  S.Hofmann                                  *
*                                mc_sho@gmx.de                                *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  30.04.2008 22:16
*  Geraete Bezeichnung   :  AMOLED-Adapter
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	Fr Hardware Festlegungen des Projekts
*
******************************************************************************/

#ifndef _HW_H_
#define _HW_H_


#include <iom168v.h>
#include "types.h"

//- Belegung der Prozessorports -----------------------------------------------


// PB0                          AMOLED_POWER  
// PB1                          RST_S6E63D6
// PB2                          SEL_S6E63D6
// PB3                          MOSI
// PB4                          MISO   
// PB5                          SCK   
//
// PC0                          frei
// PC1                          frei
// PC2                          frei
// PC3                          frei
// PC4                          frei
// PC5                          frei
// PC6                          /RESET
// PC7                          frei
//
// PD0                          RXD
// PD1                          TXD
// PD2 (INT0)                   frei
// PD3 (INT1)                   frei
// PD4                          AMOLED_POWER
// PD5                          RST_S6E63D6
// PD6                          frei
// PD7                          frei
//
//
//- Timing
#define CPU_CLOCK               80000000L  // 8,0000 MHz Takt
//
//- Belegung Portbits und Ports
//
//- Bits
#define RST_S6E63D6   1            //- Belegung auf dem Testboard
#define AMOLED_POWER  0            //- Belegung auf dem Testboard
#define SEL_S6E63D6   2            //- Belegung auf dem Testboard
#define BU_MOSI       3
#define BU_SCK        5
#define BU_SS         2

#define SEL_S6E63D6_LOW()         CLEARBIT(PORTB, SEL_S6E63D6)
#define SEL_S6E63D6_HIGH()        SETBIT(PORTB, SEL_S6E63D6)

#define RST_S6E63D6_ON()         CLEARBIT(PORTB, RST_S6E63D6)
#define RST_S6E63D6_OFF()        SETBIT(PORTB, RST_S6E63D6)

#define AMOLED_POWER_ON()        SETBIT(PORTB, AMOLED_POWER)
#define AMOLED_POWER_OFF()       CLEARBIT(PORTB, AMOLED_POWER)
//- Config SPI ----------------------------------------------------------------
//
//                                SPIE = 1 int enable, SPIE = 0 int disable
//                                SPE  = 1 SPI enable, SPE  = 0 SPI disable
//                                DORD = 1 shift LSB,  DORD = 0 shift MSB
//                                MSTR = 1 SPI Master, MSTR = 0 SPI Slave
                                   
//                                SPIE  SPE  DORD  MSTR  CPOL  CPHA  SPR1  SPR0 
#define SPI_KONTRAST  0x70      //  0    1    1     1      0     0    0      0
#define SPI_4094      0x5C      //  0    1    0     1      1     1    0      0
#define SPI_MCP_WR    0x50      //  0    1    0     1      0     0    0      0
#define SPI_TLV5638   0x5C      //  0    1    0     1      1     1    0      0
#define SPI_ADS8341_W 0x54      //  0    1    0     1      0     1    0      0
#define SPI_ADS8341_R 0x50      //  0    1    0     1      0     0    0      0
#define SPI_BU8793    0x58      //  0    1    0     1      1     0    0      0
#define SPI_S6E63D6   0x5C      //  0    1    0     1      1     1    0      0


#endif