/*******************************************************************************
*                      Eppendorf Instrumente GmbH                              *
*                   Barkhausenweg 1, D-22339 Hamburg                           *
********************************************************************************
*  $Source: /home/CVS/pipette_xem/include/types.h,v $
*------------------------------------------------------------------------------*
*  Datum der 1. Version  :  17.06.2004
*  Geraete Bezeichnung   :  pipette4986
*------------------------------------------------------------------------------*
*- $Id: types.h,v 1.1.1.1 2004/07/01 09:04:07 sho Exp $
*------------------------------------------------------------------------------*
*
*  Headerfile
*  ----------
*  Fuer allgemeine Dinge des Projekts
*
*******************************************************************************/
#ifndef TYPES_H
#define TYPES_H

//allgemeine Define's *********************************************************

//- Datentypen ----------------------------------------------------------------


#ifndef __WIN32__
typedef unsigned char BOOL;
#endif

#ifndef INLINE
#define INLINE
#endif

#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define LONG_LOW(x)  ((long)x & 0x000000FF)
#define LONG_HIGH(x) ((long)x >> 16)

#define LOW(x)  ((short)x & 0x0FF)
#define HIGH(x) ((short)x >> 8)
#define BSW(x)	((((x) >> 8) & 0x00FF) | (((x) << 8) & 0xFF00))

#define MINIMUM(x,y) ((x<y) ? x : y)
#define MAXIMUM(x,y) ((x>y) ? x : y)

typedef enum {
   EIN,                      // Schalter ein
   AUS                        // Schalter aus
   } Schalter;

#ifndef __C51__
typedef unsigned long DWORD;	//   Type DWORD definition
#endif

#ifndef WORD
typedef unsigned short WORD;	//   Type WORD definition
#endif

#ifndef SHORT
typedef short SHORT;	         //   Type SHORT definition
#endif

#ifndef CHAR
typedef char CHAR;	         //   Type CHAR definition
#endif

typedef unsigned char BYTE;	//   Type BYTE definition

/* enable global interrupts */
#define GIE      	        	   (SREG |= BIT(7))

/* disable global interrupts */
#define GID       	         	   (SREG &= ~BIT(7))

#define SLEEP()	asm("sleep")

#ifndef BV
  #define BV(x) (1 << (x))
#endif
/*
// enables an unsigned char to be used as a series of booleans
#define BIT(x)	           (1 << (x))
#define SETBIT(x, y)   	   (x |= y)
#define CLEARBIT(x, y) 	   (x &= ~y)
#define CHECKBIT(x, y) 	   (x & y)
*/
#define S_BIT(x)	           (1 << (x))

/* Set and clear bits in I/O registers can also be declared as macros */
#define SETBIT(ADDRESS,BIT)   (ADDRESS |= (1<<BIT))
#define CLEARBIT(ADDRESS,BIT) (ADDRESS &= ~(1<<BIT))
/* Macro for testing of a single bit in an I/O location*/
#define CHECKBIT(ADDRESS,BIT) (ADDRESS & (1<<BIT))
#define O_CHECKBIT(x, y)      ((x & S_BIT(y)) >> (y))
#define IRPORT_PARAM(p) ((BYTE *)((p)+1))
#endif
