/******************************************************************************
*                                  S.Hofmann                                  *
*                                mc_sho@gmx.de                                *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  30.04.2008 22:16
*  Geraete Bezeichnung   :  AMOLED-Adapter
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*	Sourcefile
*	----------
*	AMOLED Controller S6E63D6
*
******************************************************************************/

#include "hw.h"
#include "spi.h"
#include "types.h"
#include "s6e63d6.h"


//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void WriteIndex( WORD wData )
{
     
     SEL_S6E63D6_LOW();                // Sel SPI S6E63D6   
     SpiWriteByte( GOLED_DEVICE_ID );  // 1st 8Bit 
     SpiWriteByte( HIGH(wData) );      // 2st 8Bit
     SpiWriteByte( LOW(wData) );       // 3st 8Bit
     SEL_S6E63D6_HIGH();
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void WriteParameter( WORD wData )
{
     
     SEL_S6E63D6_LOW();                // Sel SPI S6E63D6   
     SpiWriteByte( GOLED_DEVICE_ID | GOLED_RS ); // 1st 8Bit 
     SpiWriteByte( HIGH(wData) );      // 2st 8Bit
     SpiWriteByte( LOW(wData) );       // 3st 8Bit
     SEL_S6E63D6_HIGH();
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
WORD ReadS6E63D6( void )
{
   WORD data;
   WORD data1 = 0;
     
     SEL_S6E63D6_LOW();                // Sel SPI S6E63D6   
     SpiWriteByte( GOLED_DEVICE_ID | GOLED_RS | GOLED_RW );  // read adr  Bit 0 to null
     SpiWriteByte( 0x00 );            // dummy send
     
     data = SpiReadByte();
     data = data << 8;
     data1 = SpiReadByte();
     data = data | data1;
     SEL_S6E63D6_HIGH();
     
     return data;   
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void Goled_Adr( DWORD adr )
{
   
   union{ 
        DWORD lAdrOled; 
        WORD buffer[1];
   } uAdrLowHigh; 
   
   
	WORD wLow  = 0;
	WORD wHigh = 0;
	
	uAdrLowHigh.lAdrOled = adr;
	wLow =  (uAdrLowHigh.buffer[0] & 0x00FF);   
	uAdrLowHigh.lAdrOled >>= 8;
	wHigh = (uAdrLowHigh.buffer[0] & 0x01FF);
  
  WriteIndex( GOLED_GRAM_ADDRESS_SET_LOW );
  WriteParameter( wLow );             // 
  WriteIndex( GOLED_GRAM_ADDRESS_SET_HIGH );
  WriteParameter( wHigh );            // 
  WriteIndex( GOLED_GRAM_WRITE_READ );    // write GRAM  
   	   
	
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
//void Goled_SetWindow( BYTE bVstart, BYTE bVend, BYTE bHsart, BYTE bHend )
BYTE Goled_SetWindow( WORD bx, WORD by, WORD bLine, WORD bcol )
{
	BYTE bStatus = 0;
	WORD bTemp = 0;
	
	if(( (bx + bcol)> GOLED_X ) || ( (by + bLine)> GOLED_Y ))
		   return 1;
  
  bTemp = (bx << 8 );
  
  bTemp |= bx + bcol;
	WriteIndex( GOLED_VERTICAL_RAM_ADDRESS_POS_VS );   
	WriteParameter( by ); 
	WriteIndex( GOLED_VERTICAL_RAM_ADDRESS_POS_VE );   
	WriteParameter( by + bLine ); 
	WriteIndex( GOLED_HORIZONTAL_RAM_ADR_POS );   
	WriteParameter( bTemp ); 
	Goled_Adr( 0);
	
	
	return bStatus;
	
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void WriteDisplay( WORD wColForeground, 
                   WORD wColBackground,  
                   WORD  wColumnCount,
                   WORD  wLineCount,
                   BYTE bx,
                   BYTE by,
                   const char *pArray )
{
	  BYTE x,y,z,a;
	  BYTE pixels;

	  
	 //- Adresse setzen
	 //Goled_Adr( lAdr );
   Goled_SetWindow( bx, by, wLineCount-1, wColumnCount-1 );
   
   
   
	 for( y = 0; y < wLineCount; y++ )
	 {  
	     //for( x = 0; x < wColumnCount; x++ )
	     x = wColumnCount;
	     while( x > 0 )
	     {
	   	      
	   	      pixels = (char)*pArray++;
	   	      
	   	      if( x > 8 )
	   	      {
	   	      	  a = 8;
	   	      	  x -= 8;
	   	      }
	   	      else
	   	      {
	   	      	  a = x;
	   	          x = 0;
	   	      }
	          for( z = 0; z < a; z++ )
	          {
	              if( pixels & 0x80 )
	      	          WriteParameter( wColForeground );
	              else
	      	          WriteParameter( wColBackground );
	              pixels = pixels << 1;
	          }
	     }
	     //- neue Zeile
	     //lAdr += GOLED_LINE_ADR;
	     //- Adresse setzen
	     //Goled_Adr( lAdr );
	     
	  } 
}
