/******************************************************************************
*                                  S.Hofmann                                  *
*                                mc_sho@gmx.de                                *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  30.04.2008 22:16
*  Geraete Bezeichnung   :  AMOLED-Adapter
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*	MAIN
*	----------
*	AMOLED-Adapter
*
******************************************************************************/
// Target : M168
// Crystal: 8.0000Mhz


#include <macros.h>
#include "spi.h"
#include "hw.h"
#include "types.h"
#include "s6e63d6.h"
#include "testtext.h"




void port_init(void)
{
 //- Port = 1 und DDR = 1   Output High
 //- Port = 0 und DDR = 1   Output Low
 //- Port = 0 und DDR = 0   Input Tri-state ( ohne internen Pull-Up )


// PORTA = 0x00;
// DDRA  = 0x00;
 PORTB = (1<<SEL_S6E63D6) | (1<<BU_SS) | (1<<RST_S6E63D6);
 DDRB  = (1<<SEL_S6E63D6) | (1<<BU_MOSI) | (1<<BU_SCK) | (1<<BU_SS) | (1<<RST_S6E63D6) | (1<<AMOLED_POWER);
 PORTC = 0x00; 
 DDRC  = 0x00;
 PORTD = 0x00;
 DDRD  = 0x00; 



}
/*
//SPI initialize
// clock rate: 4000000hz
void spi_init(void)
{
 SPCR = 0x50; //setup SPI
 SPSR = 0x01; //setup SPI
}
*/
#pragma interrupt_handler int0_isr:2
void int0_isr(void)
{
 //external interupt on INT0
}

//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();
 spi_init();

 MCUCR = 0x00;
 EICRA = 0x00; //extended ext ints
 EIMSK = 0x00;
 
 TIMSK0 = 0x00; //timer 0 interrupt sources
 TIMSK1 = 0x00; //timer 1 interrupt sources
 TIMSK2 = 0x00; //timer 2 interrupt sources
 
 PCMSK0 = 0x00; //pin change mask 0 
 PCMSK1 = 0x00; //pin change mask 1 
 PCMSK2 = 0x00; //pin change mask 2
 PCICR = 0x00; //pin change enable 
 PRR = 0x00; //power controller
 SEI(); //re-enable interrupts
}

void main( void )
{
    volatile BYTE dummy;
    DWORD x,y,lOledAdr, lOld_OledAdr;
    //- HW Init
    BYTE bx, by;
    
    init_devices();    

    RST_S6E63D6_ON();
    NOP();
    NOP();
    NOP();
    NOP();
    RST_S6E63D6_OFF();
   
    WriteIndex( GOLED_ENTRY_MODE );
    WriteParameter(GOLED_ID1 | GOLED_ID0 | GOLED_SS ); // 16bit Mode
    WriteIndex( GOLED_STAND_BY );
    WriteParameter(0x0000 );                // Standby off

    WriteIndex( GOLED_DISPLAY_CONTROL1 );
    WriteParameter( 0x0000 );               // display off
    
    WriteIndex( GOLED_OSCILLATOR_CONTROL );
    WriteParameter(0x0028 );                // X1.352(Max.) 80Hz

    WriteIndex( 0x00F8 );                   // Reg. ??
    WriteParameter(0x0014 );                // Vgh=+6v
    WriteIndex( 0x00F9 );                   // Reg. ??
    WriteParameter(0x0014 );                // Vgl=-6v
    


//- Gamma Register Setting:
    WriteIndex( GOLED_GAMMA_TOP_BOTTO_CONTROL_R );
    WriteParameter( 0x2580 );        //  
    WriteIndex( GOLED_GAMMA_TOP_BOTTO_CONTROL_G );
    WriteParameter( 0x2780 );        // 
    WriteIndex( GOLED_GAMMA_TOP_BOTTO_CONTROL_B );
    WriteParameter( 0x3380 );        // 
    WriteIndex( GOLED_GAMMA_CONTROL_R_1_2 );
    WriteParameter( 0x1D18 );        //  
    WriteIndex( GOLED_GAMMA_CONTROL_R_3_4 );
    WriteParameter( 0x1F11 );        // 
    WriteIndex( GOLED_GAMMA_CONTROL_G_1_2 );
    WriteParameter( 0x2419 );        // 
    WriteIndex( GOLED_GAMMA_CONTROL_G_3_4 );
    WriteParameter( 0x1A14 );        //  
    WriteIndex( GOLED_GAMMA_CONTROL_B_1_2 );
    WriteParameter( 0x211A );        // 
    WriteIndex( GOLED_GAMMA_CONTROL_B_3_4 );
    WriteParameter( 0x2013 );        // 
          
    AMOLED_POWER_ON();                      // (-4,4V and +4,6V on)

    WriteIndex( GOLED_DISPLAY_CONTROL1 );
    WriteParameter( GOLED_DISP_ON );        // display on
        
    WriteIndex( GOLED_GRAM_WRITE_READ );    // write GRAM

       while(1)
       {
        
      
    
         Goled_Adr( 0 );
         
         //- Clear Display
         for(x = 0; x < (320 * 240 ); x++ )
             WriteParameter(0x0000);       // Clear Display
         
         //Goled_Adr( lOledAdr );          
         //- Write AMOLED
         
         //lOledAdr = 0;  //- Zeilenanfang
         //lOld_OledAdr = lOledAdr; // und retten
         bx = 0; by = 0;
         WriteDisplay( GOLED_RED, GOLED_GREY,AMOLED_COL,20, bx, by, Text_AMOLED[0] );
         bx += AMOLED_COL; // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_GREY,AMOLED_COL,20, bx, by, Text_AMOLED[20] );
         bx += AMOLED_COL; // 3 Bytes in Column
         WriteDisplay( GOLED_YELLOW, GOLED_GREY,AMOLED_COL,20, bx, by, Text_AMOLED[40] );
         bx += AMOLED_COL; // 3 Bytes in Column
         WriteDisplay( GOLED_BLUE, GOLED_GREY,AMOLED_COL,20, bx, by, Text_AMOLED[60] );
         bx += AMOLED_COL; // 3 Bytes in Column
         WriteDisplay( GOLED_MAGENTA, GOLED_GREY,AMOLED_COL,20, bx, by, Text_AMOLED[80] );
         bx += AMOLED_COL; // 3 Bytes in Column
         WriteDisplay( GOLED_CYAN, GOLED_GREY,AMOLED_COL,20, bx, by, Text_AMOLED [100] );
         bx   = 0;
         by  += 20; // neue Zeilen ( 20 Pixel )
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [0] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [20] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [40] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [60] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [80] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [100] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [120] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [140] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_WHITE, GOLED_BLACK,3,20, bx, by, Text_C0283QGLX [160] );
         
         bx  = 0;
         by += 20;
         
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [0] ); // Zahl 0
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [14] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [28] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [42] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [56] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [70] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [84] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [98] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [112] );
         lOledAdr += (2*8); // 3 Bytes in Column
         WriteDisplay( GOLED_ORANGE, GOLED_BLACK,2,14, bx, by, Text_Zahlen [126] ); // Zahl 9
         lOledAdr += (2*8); // 3 Bytes in Column

         bx  = 0;
         by += 14;
         
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [0] ); // Zahl 0
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [1*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [2*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [3*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [4*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [5*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [6*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [7*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [8*36] );
         lOledAdr += (3*8); // 3 Bytes in Column
         WriteDisplay( GOLED_GREEN, GOLED_BLACK,3,36, bx, by, Text_ZahlenGross [9*36] ); // Zahl 9
         lOledAdr += (3*8); // 3 Bytes in Column         
       }
   
}